<?php
/**
 * OrderData
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CommunicationManagerClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Communication manager
 *
 * Ensi Communication manager
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CommunicationManagerClient\Dto;

use \ArrayAccess;
use \Ensi\CommunicationManagerClient\ObjectSerializer;

/**
 * OrderData Class Doc Comment
 *
 * @category Class
 * @description Данные события
 * @package  Ensi\CommunicationManagerClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class OrderData implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'OrderData';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'subject' => 'string',
        'to' => 'string[]',
        'order_number' => 'string',
        'create_date' => 'string',
        'receiver_name' => 'string',
        'receiver_email' => 'string',
        'receiver_phone' => 'string',
        'delivery_address' => 'string',
        'delivery_comment' => 'string',
        'delivery_date' => 'string',
        'delivery_time' => 'string',
        'delivery_cost' => 'string',
        'basket_items' => '\Ensi\CommunicationManagerClient\Dto\BasketItem[]',
        'items_cost' => 'string',
        'order_cost' => 'string',
        'total_count' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'subject' => null,
        'to' => null,
        'order_number' => null,
        'create_date' => null,
        'receiver_name' => null,
        'receiver_email' => null,
        'receiver_phone' => null,
        'delivery_address' => null,
        'delivery_comment' => null,
        'delivery_date' => null,
        'delivery_time' => null,
        'delivery_cost' => null,
        'basket_items' => null,
        'items_cost' => null,
        'order_cost' => null,
        'total_count' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'subject' => false,
        'to' => false,
        'order_number' => false,
        'create_date' => false,
        'receiver_name' => false,
        'receiver_email' => false,
        'receiver_phone' => false,
        'delivery_address' => false,
        'delivery_comment' => false,
        'delivery_date' => false,
        'delivery_time' => false,
        'delivery_cost' => false,
        'basket_items' => false,
        'items_cost' => false,
        'order_cost' => false,
        'total_count' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'subject' => 'subject',
        'to' => 'to',
        'order_number' => 'order_number',
        'create_date' => 'create_date',
        'receiver_name' => 'receiver_name',
        'receiver_email' => 'receiver_email',
        'receiver_phone' => 'receiver_phone',
        'delivery_address' => 'delivery_address',
        'delivery_comment' => 'delivery_comment',
        'delivery_date' => 'delivery_date',
        'delivery_time' => 'delivery_time',
        'delivery_cost' => 'delivery_cost',
        'basket_items' => 'basket_items',
        'items_cost' => 'items_cost',
        'order_cost' => 'order_cost',
        'total_count' => 'total_count'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'subject' => 'setSubject',
        'to' => 'setTo',
        'order_number' => 'setOrderNumber',
        'create_date' => 'setCreateDate',
        'receiver_name' => 'setReceiverName',
        'receiver_email' => 'setReceiverEmail',
        'receiver_phone' => 'setReceiverPhone',
        'delivery_address' => 'setDeliveryAddress',
        'delivery_comment' => 'setDeliveryComment',
        'delivery_date' => 'setDeliveryDate',
        'delivery_time' => 'setDeliveryTime',
        'delivery_cost' => 'setDeliveryCost',
        'basket_items' => 'setBasketItems',
        'items_cost' => 'setItemsCost',
        'order_cost' => 'setOrderCost',
        'total_count' => 'setTotalCount'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'subject' => 'getSubject',
        'to' => 'getTo',
        'order_number' => 'getOrderNumber',
        'create_date' => 'getCreateDate',
        'receiver_name' => 'getReceiverName',
        'receiver_email' => 'getReceiverEmail',
        'receiver_phone' => 'getReceiverPhone',
        'delivery_address' => 'getDeliveryAddress',
        'delivery_comment' => 'getDeliveryComment',
        'delivery_date' => 'getDeliveryDate',
        'delivery_time' => 'getDeliveryTime',
        'delivery_cost' => 'getDeliveryCost',
        'basket_items' => 'getBasketItems',
        'items_cost' => 'getItemsCost',
        'order_cost' => 'getOrderCost',
        'total_count' => 'getTotalCount'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('subject', $data, null);
        $this->setIfExists('to', $data, null);
        $this->setIfExists('order_number', $data, null);
        $this->setIfExists('create_date', $data, null);
        $this->setIfExists('receiver_name', $data, null);
        $this->setIfExists('receiver_email', $data, null);
        $this->setIfExists('receiver_phone', $data, null);
        $this->setIfExists('delivery_address', $data, null);
        $this->setIfExists('delivery_comment', $data, null);
        $this->setIfExists('delivery_date', $data, null);
        $this->setIfExists('delivery_time', $data, null);
        $this->setIfExists('delivery_cost', $data, null);
        $this->setIfExists('basket_items', $data, null);
        $this->setIfExists('items_cost', $data, null);
        $this->setIfExists('order_cost', $data, null);
        $this->setIfExists('total_count', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets subject
     *
     * @return string|null
     */
    public function getSubject()
    {
        return $this->container['subject'];
    }

    /**
     * Sets subject
     *
     * @param string|null $subject subject
     *
     * @return $this
     */
    public function setSubject($subject)
    {


        /*if (is_null($subject)) {
            throw new \InvalidArgumentException('non-nullable subject cannot be null');
        }*/
        $this->container['subject'] = $subject;

        return $this;
    }

    /**
     * Gets to
     *
     * @return string[]|null
     */
    public function getTo()
    {
        return $this->container['to'];
    }

    /**
     * Sets to
     *
     * @param string[]|null $to to
     *
     * @return $this
     */
    public function setTo($to)
    {


        /*if (is_null($to)) {
            throw new \InvalidArgumentException('non-nullable to cannot be null');
        }*/
        $this->container['to'] = $to;

        return $this;
    }

    /**
     * Gets order_number
     *
     * @return string|null
     */
    public function getOrderNumber()
    {
        return $this->container['order_number'];
    }

    /**
     * Sets order_number
     *
     * @param string|null $order_number order_number
     *
     * @return $this
     */
    public function setOrderNumber($order_number)
    {


        /*if (is_null($order_number)) {
            throw new \InvalidArgumentException('non-nullable order_number cannot be null');
        }*/
        $this->container['order_number'] = $order_number;

        return $this;
    }

    /**
     * Gets create_date
     *
     * @return string|null
     */
    public function getCreateDate()
    {
        return $this->container['create_date'];
    }

    /**
     * Sets create_date
     *
     * @param string|null $create_date create_date
     *
     * @return $this
     */
    public function setCreateDate($create_date)
    {


        /*if (is_null($create_date)) {
            throw new \InvalidArgumentException('non-nullable create_date cannot be null');
        }*/
        $this->container['create_date'] = $create_date;

        return $this;
    }

    /**
     * Gets receiver_name
     *
     * @return string|null
     */
    public function getReceiverName()
    {
        return $this->container['receiver_name'];
    }

    /**
     * Sets receiver_name
     *
     * @param string|null $receiver_name receiver_name
     *
     * @return $this
     */
    public function setReceiverName($receiver_name)
    {


        /*if (is_null($receiver_name)) {
            throw new \InvalidArgumentException('non-nullable receiver_name cannot be null');
        }*/
        $this->container['receiver_name'] = $receiver_name;

        return $this;
    }

    /**
     * Gets receiver_email
     *
     * @return string|null
     */
    public function getReceiverEmail()
    {
        return $this->container['receiver_email'];
    }

    /**
     * Sets receiver_email
     *
     * @param string|null $receiver_email receiver_email
     *
     * @return $this
     */
    public function setReceiverEmail($receiver_email)
    {


        /*if (is_null($receiver_email)) {
            throw new \InvalidArgumentException('non-nullable receiver_email cannot be null');
        }*/
        $this->container['receiver_email'] = $receiver_email;

        return $this;
    }

    /**
     * Gets receiver_phone
     *
     * @return string|null
     */
    public function getReceiverPhone()
    {
        return $this->container['receiver_phone'];
    }

    /**
     * Sets receiver_phone
     *
     * @param string|null $receiver_phone receiver_phone
     *
     * @return $this
     */
    public function setReceiverPhone($receiver_phone)
    {


        /*if (is_null($receiver_phone)) {
            throw new \InvalidArgumentException('non-nullable receiver_phone cannot be null');
        }*/
        $this->container['receiver_phone'] = $receiver_phone;

        return $this;
    }

    /**
     * Gets delivery_address
     *
     * @return string|null
     */
    public function getDeliveryAddress()
    {
        return $this->container['delivery_address'];
    }

    /**
     * Sets delivery_address
     *
     * @param string|null $delivery_address delivery_address
     *
     * @return $this
     */
    public function setDeliveryAddress($delivery_address)
    {


        /*if (is_null($delivery_address)) {
            throw new \InvalidArgumentException('non-nullable delivery_address cannot be null');
        }*/
        $this->container['delivery_address'] = $delivery_address;

        return $this;
    }

    /**
     * Gets delivery_comment
     *
     * @return string|null
     */
    public function getDeliveryComment()
    {
        return $this->container['delivery_comment'];
    }

    /**
     * Sets delivery_comment
     *
     * @param string|null $delivery_comment delivery_comment
     *
     * @return $this
     */
    public function setDeliveryComment($delivery_comment)
    {


        /*if (is_null($delivery_comment)) {
            throw new \InvalidArgumentException('non-nullable delivery_comment cannot be null');
        }*/
        $this->container['delivery_comment'] = $delivery_comment;

        return $this;
    }

    /**
     * Gets delivery_date
     *
     * @return string|null
     */
    public function getDeliveryDate()
    {
        return $this->container['delivery_date'];
    }

    /**
     * Sets delivery_date
     *
     * @param string|null $delivery_date delivery_date
     *
     * @return $this
     */
    public function setDeliveryDate($delivery_date)
    {


        /*if (is_null($delivery_date)) {
            throw new \InvalidArgumentException('non-nullable delivery_date cannot be null');
        }*/
        $this->container['delivery_date'] = $delivery_date;

        return $this;
    }

    /**
     * Gets delivery_time
     *
     * @return string|null
     */
    public function getDeliveryTime()
    {
        return $this->container['delivery_time'];
    }

    /**
     * Sets delivery_time
     *
     * @param string|null $delivery_time delivery_time
     *
     * @return $this
     */
    public function setDeliveryTime($delivery_time)
    {


        /*if (is_null($delivery_time)) {
            throw new \InvalidArgumentException('non-nullable delivery_time cannot be null');
        }*/
        $this->container['delivery_time'] = $delivery_time;

        return $this;
    }

    /**
     * Gets delivery_cost
     *
     * @return string|null
     */
    public function getDeliveryCost()
    {
        return $this->container['delivery_cost'];
    }

    /**
     * Sets delivery_cost
     *
     * @param string|null $delivery_cost delivery_cost
     *
     * @return $this
     */
    public function setDeliveryCost($delivery_cost)
    {


        /*if (is_null($delivery_cost)) {
            throw new \InvalidArgumentException('non-nullable delivery_cost cannot be null');
        }*/
        $this->container['delivery_cost'] = $delivery_cost;

        return $this;
    }

    /**
     * Gets basket_items
     *
     * @return \Ensi\CommunicationManagerClient\Dto\BasketItem[]|null
     */
    public function getBasketItems()
    {
        return $this->container['basket_items'];
    }

    /**
     * Sets basket_items
     *
     * @param \Ensi\CommunicationManagerClient\Dto\BasketItem[]|null $basket_items basket_items
     *
     * @return $this
     */
    public function setBasketItems($basket_items)
    {


        /*if (is_null($basket_items)) {
            throw new \InvalidArgumentException('non-nullable basket_items cannot be null');
        }*/
        $this->container['basket_items'] = $basket_items;

        return $this;
    }

    /**
     * Gets items_cost
     *
     * @return string|null
     */
    public function getItemsCost()
    {
        return $this->container['items_cost'];
    }

    /**
     * Sets items_cost
     *
     * @param string|null $items_cost Суммарная стоимость товаров заказа
     *
     * @return $this
     */
    public function setItemsCost($items_cost)
    {


        /*if (is_null($items_cost)) {
            throw new \InvalidArgumentException('non-nullable items_cost cannot be null');
        }*/
        $this->container['items_cost'] = $items_cost;

        return $this;
    }

    /**
     * Gets order_cost
     *
     * @return string|null
     */
    public function getOrderCost()
    {
        return $this->container['order_cost'];
    }

    /**
     * Sets order_cost
     *
     * @param string|null $order_cost Итоговая стоимость заказа
     *
     * @return $this
     */
    public function setOrderCost($order_cost)
    {


        /*if (is_null($order_cost)) {
            throw new \InvalidArgumentException('non-nullable order_cost cannot be null');
        }*/
        $this->container['order_cost'] = $order_cost;

        return $this;
    }

    /**
     * Gets total_count
     *
     * @return int|null
     */
    public function getTotalCount()
    {
        return $this->container['total_count'];
    }

    /**
     * Sets total_count
     *
     * @param int|null $total_count Суммарное количество товаров в заказе
     *
     * @return $this
     */
    public function setTotalCount($total_count)
    {


        /*if (is_null($total_count)) {
            throw new \InvalidArgumentException('non-nullable total_count cannot be null');
        }*/
        $this->container['total_count'] = $total_count;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


